package com.repair.controller;


import com.repair.api.RepairTrackRecordControllerAPI;
import com.repair.common.utils.paramUtils;
import com.repair.model.pojo.RepairTrackRecord;
import com.repair.model.result.CommonResult;
import com.repair.model.result.PageUtils;
import com.repair.services.RepairTrackRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author ceshi
 * @since 2023-07-20
 */
@RestController
public class RepairTrackRecordController implements RepairTrackRecordControllerAPI {

    @Autowired
    private RepairTrackRecordService repairTrackRecordService;

    /**
     * 新增跟踪记录数据
     * @param rc 跟踪记录数据
     * @param bindingResult 是否为空判断
     * @return
     */
    @Override
    public CommonResult insertRepairTrackRecord(RepairTrackRecord rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairTrackRecordService.insertRepairTrackRecord(rc);

        return result > 0 ? CommonResult.ok("添加成功") : CommonResult.fail("添加失败");
    }

    /**
     * 更新跟踪记录数据
     * @param rc 跟踪记录数据
     * @param bindingResult 是否为空判断
     * @return
     */
    @Override
    public CommonResult updateRepairTrackRecordById(RepairTrackRecord rc, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            String st = paramUtils.getParamError(bindingResult);
            return CommonResult.fail(st);
        }

        int result = repairTrackRecordService.updateRepairTrackRecord(rc);

        return result > 0 ? CommonResult.ok("修改成功") : CommonResult.fail("修改失败");
    }

    /**
     * 跟踪记录分页数据查询
     * @param currentPage 当前页数
     * @param pageCount 一页数据条数
     * @param name 查询名称
     * @return
     */
    @Override
    public CommonResult queryPageRepairTrackRecords(int currentPage, int pageCount, String name) {
        PageUtils<RepairTrackRecord> result = repairTrackRecordService.queryPageRepairTrackRecords(currentPage, pageCount, name);

        return CommonResult.ok(result);
    }

    /**
     * 根据数据ID删除跟踪记录
     * @param id 数据ID
     * @return
     */
    @Override
    public CommonResult deleteRepairTrackRecordById(int id) {
        RepairTrackRecord data = repairTrackRecordService.getRepairById(id);
        if (data == null) {
            return CommonResult.fail("当前数据不存在，删除失败！");
        }

        int result = repairTrackRecordService.deleteRepairTrackRecordById(id);

        return result > 0 ? CommonResult.ok("删除成功") : CommonResult.fail("删除失败");
    }
}

